libsigc++: sigc::slot4< T_return, T_arg1, T_arg2, T_arg3, T_arg4 > Class Template Reference

# sigc::slot4< T_return, T_arg1, T_arg2, T_arg3, T_arg4 > Class Template Reference
[Slots]

Converts an arbitrary functor to a unified type which is opaque. More...

`#include <sigc++/functors/slot.h>`

Inheritance diagram for sigc::slot4< T_return, T_arg1, T_arg2, T_arg3, T_arg4 >:
[legend]

List of all members.

## Public Types
typedef T_return | result_type
typedef type_trait< T_arg1 >::take | arg1_type_
typedef type_trait< T_arg2 >::take | arg2_type_
typedef type_trait< T_arg3 >::take | arg3_type_
typedef type_trait< T_arg4 >::take | arg4_type_
## Public Member Functions
T_return | operator() (arg1_type_ _A_a1, arg2_type_ _A_a2, arg3_type_ _A_a3, arg4_type_ _A_a4) const
| Invoke the contained functor unless slot is in blocking state.
template<class T_functor >
| slot4 (const T_functor& _A_func)
| Constructs a slot from an arbitrary functor.
| slot4 (const slot4& src)
slot4& | operator= (const slot4& src)
| Overrides this slot making a copy from another slot.

## Detailed Description

### template <class T_return, class T_arg1, class T_arg2, class T_arg3, class T_arg4>
class sigc::slot4< T_return, T_arg1, T_arg2, T_arg3, T_arg4 >

Converts an arbitrary functor to a unified type which is opaque.

sigc::slot itself is a functor or to be more precise a closure. It contains a single, arbitrary functor (or closure) that is executed in operator()().

The template arguments determine the function signature of operator()():

- T_return The return type of operator()().
- T_arg1 Argument type used in the definition of operator()(). The default `nil` means no argument.
- T_arg2 Argument type used in the definition of operator()(). The default `nil` means no argument.
- T_arg3 Argument type used in the definition of operator()(). The default `nil` means no argument.
- T_arg4 Argument type used in the definition of operator()(). The default `nil` means no argument.

To use simply assign the slot to the desired functor. If the functor is not compatible with the parameter list defined with the template arguments compiler errors are triggered. When called the slot will invoke the functor with minimal copies. block() and unblock() can be used to block the functor's invocation from operator()() temporarily.

You should use the more convenient unnumbered sigc::slot template.

## Constructor & Destructor Documentation

template <class T_return , class T_arg1 , class T_arg2 , class T_arg3 , class T_arg4 >
template <class T_functor >

sigc::slot4< T_return, T_arg1, T_arg2, T_arg3, T_arg4 >::slot4 | ( | const T_functor & | _A_func | ) | `[inline]`

Constructs a slot from an arbitrary functor.

Parameters:

  | _A_func | The desirer functor the new slot should be assigned to.

## Member Function Documentation

template <class T_return , class T_arg1 , class T_arg2 , class T_arg3 , class T_arg4 >

T_return sigc::slot4< T_return, T_arg1, T_arg2, T_arg3, T_arg4 >::operator() | ( | arg1_type_ | _A_a1,
|  | arg2_type_ | _A_a2,
|  | arg3_type_ | _A_a3,
|  | arg4_type_ | _A_a4 |
| ) |  |  | const`[inline]`

Invoke the contained functor unless slot is in blocking state.

Parameters:

  | _A_a1 | Argument to be passed on to the functor.
  | _A_a2 | Argument to be passed on to the functor.
  | _A_a3 | Argument to be passed on to the functor.
  | _A_a4 | Argument to be passed on to the functor.

Returns:
  The return value of the functor invocation.

template <class T_return , class T_arg1 , class T_arg2 , class T_arg3 , class T_arg4 >

slot4& sigc::slot4< T_return, T_arg1, T_arg2, T_arg3, T_arg4 >::operator= | ( | const slot4< T_return, T_arg1, T_arg2, T_arg3, T_arg4 >& | src | ) | `[inline]`

Overrides this slot making a copy from another slot.

Parameters:

  | src | The slot from which to make a copy.

Returns:
  `this`.

Reimplemented from sigc::slot_base.